SpellReduxSettings = {}
NEW_SPELL = "<New>"
NOT_LINKED = "<Not Linked>"

function SpellReduxSettings:OnLoad(frame)
	frame.name = "SpellRedux";
	
	frame.tarDebuffPanel = CreateFrame("Frame", "tarDebuffPanel", frame, "SpellReduxSettingsModel");
	frame.tarDebuffPanel.name = "Target Debuffs"
	frame.tarDebuffPanel.parent = frame.name;
	SpellReduxSettings:configureDebuffFrame(frame.tarDebuffPanel);
	
	frame.selfBuffPanel = CreateFrame("Frame", "selfBuffPanel", frame, "SpellReduxSettingsModel");
	frame.selfBuffPanel.name = "Player Buffs"
	frame.selfBuffPanel.parent = frame.name;
	-- frame:SetScript("onUpdate", SpellReduxSettings_OnShowBuffFrame);
	SpellReduxSettings:configureBuffFrame(frame.selfBuffPanel);
	
	InterfaceOptions_AddCategory(frame);
	InterfaceOptions_AddCategory(frame.tarDebuffPanel);
	InterfaceOptions_AddCategory(frame.selfBuffPanel);
end


-- ================================== BUFFS ===============================
function SpellReduxSettings:configureBuffFrame(frame)

	frame.onSelectSpell = SpellReduxSettings_onSelectSpell;
	frame.spellList = SpellReduxSettings_getPBuffSpells;
	frame.clearBoxes = clearPBBoxes;
	frame.activeSpellTarget = "player";
	frame.activeSpellTargetFilter = "HELPFUL";
	
	_G[frame:GetName().."Title"]:SetText("Player Buffs");	

	local cmbss = _G[frame:GetName().."SpellSelect"];
	UIDropDownMenu_Initialize(cmbss, SpellReduxSettings_onOpenSpellsWithNew);
	UIDropDownMenu_SetWidth(cmbss, 125, 0);
	
	local cmbsts = _G[frame:GetName().."SpellTypeSelect"];
	UIDropDownMenu_Initialize(cmbsts, SpellReduxSettings_onOpenBuffSpellType);
	UIDropDownMenu_SetWidth(cmbsts, 125, 0);
	
	local cmbas = _G[frame:GetName().."SpellSelectActive"];
	UIDropDownMenu_Initialize(cmbas, SpellReduxSettings_onOpenActiveSpells);
	UIDropDownMenu_SetWidth(cmbas, 125, 0);
	
	local cmbsip = _G[frame:GetName().."InPlaceOfSelect"];
	UIDropDownMenu_Initialize(cmbsip, SpellReduxSettings_onOpenSpellsInPlace);
	UIDropDownMenu_SetWidth(cmbsip, 125, 0);

	_G[frame:GetName().."Save"]:SetScript("OnClick", SpellReduxSettings_saveSpell); 
	_G[frame:GetName().."Delete"]:SetScript("OnClick", SpellReduxSettings_deleteSpell); 
	
	clearPBBoxes(frame);
end

local activeSpells = {};
function SpellReduxSettings:getActiveSpells(target, filter) 
	if activeSpells[target] == nil then
		activeSpells[target] = {}
	end
	local index = 1;
	local current = UnitAura(target, index,filter);
	while current ~= nil do
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellId = UnitAura(target, index, filter);
		local info = {};
		info.spell_name = name;
		info.icon = icon;
		info.spell_id = spellId;
		activeSpells[target][name] = info;
		index = index + 1;
		current = UnitAura(target, index, filter);
	end
	
	return activeSpells[target];
end


function clearPBBoxes(frame)
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelect"], NEW_SPELL, false);
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelect"], NEW_SPELL);
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellTypeSelect"], BUFF, false); 
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellTypeSelect"], BUFF);
	_G[frame:GetName().."AppliedByEdit"]:SetText("");
	_G[frame:GetName().."AppliedByEdit"]:Enable();
	_G[frame:GetName().."SpellNameEdit"]:SetText("");
	_G[frame:GetName().."SpellNameEdit"]:Enable();
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."InPlaceOfSelect"], NOT_LINKED,false);
	UIDropDownMenu_SetText(_G[frame:GetName().."InPlaceOfSelect"], NOT_LINKED);
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelectActive"], "",false);
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelectActive"], "");
	_G[frame:GetName().."DisableStackButton"]:SetChecked(false);
	_G[frame:GetName().."DisableGlowButton"]:SetChecked(true);
	_G[frame:GetName().."SpellIsProjectileButton"]:SetChecked(false);
end

function SpellReduxSettings_onOpenBuffSpellType(frame, level, menuList)
	local info      = {};
	info.text       = BUFF; --localize this
	info.func       = SpellReduxSettings_onSelectTypeBuff;
	info.arg1		= frame;
	info.arg2		= BUFF;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == BUFF;
	UIDropDownMenu_AddButton(info);
	
	-- hots 
end

function SpellReduxSettings_onSelectTypeBuff(self, arg1, arg2, checked)
	UIDropDownMenu_SetSelectedName(arg1, arg2, false);
end

function SpellReduxSettings_getPBuffSpells()
	return selfBuffSpells;
end
-- ================================== BUFFS ===============================

-- ================================== DEBUFFS ===============================
function SpellReduxSettings:configureDebuffFrame(frame)

	frame.clearBoxes = clearTDBoxes;
	frame.onSelectSpell = SpellReduxSettings_onSelectSpell;
	frame.spellList = SpellReduxSettings_getTDebuffSpells;
	frame.activeSpellTarget = "target";
	frame.activeSpellTargetFilter = "PLAYER|HARMFUL";
	
	_G[frame:GetName().."Title"]:SetText("Target Debuffs");	

	local cmbss = _G[frame:GetName().."SpellSelect"];
	UIDropDownMenu_Initialize(cmbss, SpellReduxSettings_onOpenSpellsWithNew);
	UIDropDownMenu_SetWidth(cmbss, 125, 0);
	
	local cmbsts = _G[frame:GetName().."SpellTypeSelect"];
	UIDropDownMenu_Initialize(cmbsts, SpellReduxSettings_onOpenDebuffSpellType);
	UIDropDownMenu_SetWidth(cmbsts, 125, 0);

	local cmbas = _G[frame:GetName().."SpellSelectActive"];
	UIDropDownMenu_Initialize(cmbas, SpellReduxSettings_onOpenActiveSpells);
	UIDropDownMenu_SetWidth(cmbas, 125, 0);
	
	local cmbsip = _G[frame:GetName().."InPlaceOfSelect"];
	UIDropDownMenu_Initialize(cmbsip, SpellReduxSettings_onOpenSpellsInPlace);
	UIDropDownMenu_SetWidth(cmbsip, 125, 0);
	
	_G[frame:GetName().."Save"]:SetScript("OnClick", SpellReduxSettings_saveSpell); 
	_G[frame:GetName().."Delete"]:SetScript("OnClick", SpellReduxSettings_deleteSpell); 
	
	
	clearTDBoxes(frame);
end

function SpellReduxSettings_getTDebuffSpells()
	return targetDebuffSpells;
end

function SpellReduxSettings_onOpenDebuffSpellType(frame, level, menuList)
	local info      = {};
	info.text       = DOT; --localize this
	info.func       = SpellReduxSettings_onSelectTypeDebuff;
	info.arg1		= frame;
	info.arg2		= DOT;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == DOT;
	UIDropDownMenu_AddButton(info);
	
	info.text       = DEBUFF; --localize this
	info.func       = SpellReduxSettings_onSelectTypeDebuff;
	info.arg1		= frame;
	info.arg2		= DEBUFF;
	info.checked	= UIDropDownMenu_GetSelectedName(frame) == DEBUFF;
	UIDropDownMenu_AddButton(info);
end

function SpellReduxSettings_onSelectTypeDebuff(self, arg1, arg2, checked)
	local frame = arg1:GetParent();
	UIDropDownMenu_SetSelectedName(arg1, arg2, false);
	if (arg2 == DOT) then
		_G[frame:GetName().."AppliedByEdit"]:SetText("");	
		_G[frame:GetName().."AppliedByEdit"]:Disable();
		if NEW_SPELL == UIDropDownMenu_GetText(_G[frame:GetName().."SpellSelect"]) then
			_G[frame:GetName().."DisableStackButton"]:SetChecked(true);
		end
	elseif (arg2 == DEBUFF) then
		_G[frame:GetName().."AppliedByEdit"]:SetText("");	
		_G[frame:GetName().."AppliedByEdit"]:Enable(); 
		if NEW_SPELL == UIDropDownMenu_GetText(_G[frame:GetName().."SpellSelect"]) then
			_G[frame:GetName().."DisableStackButton"]:SetChecked(false);
		end
	end
end

function clearTDBoxes(frame)
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelect"], NEW_SPELL, false);
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelect"], NEW_SPELL);
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellTypeSelect"], DOT, false); 
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellTypeSelect"], DOT);
	_G[frame:GetName().."AppliedByEdit"]:SetText("");
	_G[frame:GetName().."AppliedByEdit"]:Disable();
	_G[frame:GetName().."SpellNameEdit"]:SetText("");
	_G[frame:GetName().."SpellNameEdit"]:Enable();
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."InPlaceOfSelect"], NOT_LINKED,false);
	UIDropDownMenu_SetText(_G[frame:GetName().."InPlaceOfSelect"], NOT_LINKED);
	UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelectActive"], "",false);
	UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelectActive"], "");
	_G[frame:GetName().."DisableStackButton"]:SetChecked(true);
	_G[frame:GetName().."DisableGlowButton"]:SetChecked(false);
	_G[frame:GetName().."SpellIsProjectileButton"]:SetChecked(false);
end

-- ================================== DEBUFFS ===============================

function SpellReduxSettings_saveSpell(self, button, down)
	local spell = {};
	spell.spell_name = UIDropDownMenu_GetText(_G[self:GetParent():GetName().."SpellSelectActive"]);
	
	-- no active spell selected?
	if spell.spell_name == "" or spell.spell_name == nil then
		spell.spell_name = _G[self:GetParent():GetName().."SpellNameEdit"]:GetText();
		if spell.spell_name == "" or spell.spell_name == nil then
			return;
		end
		local s = GetSpell(self:GetParent().spellList(),spell.spell_name);
		if s ~= nil then
			spell.spell_id = s.spell_id;
		end
	else
		for k,activeSpell in pairs(activeSpells) do
			if activeSpell[spell.spell_name] ~= nil then
				spell.spell_id = activeSpell[spell.spell_name].spell_id;
			end
		end
	end

	spell.spell_type = UIDropDownMenu_GetText(_G[self:GetParent():GetName().."SpellTypeSelect"]);
    if spell.spell_type == DEBUFF or spell.spell_type == BUFF then
		local appliedby = _G[self:GetParent():GetName().."AppliedByEdit"]:GetText();
		if appliedby ~= nil and appliedby ~= "" then spell.applied_by = appliedby end;		
	end
	
	local link_spell = UIDropDownMenu_GetText(_G[self:GetParent():GetName().."InPlaceOfSelect"])
	if link_spell ~= nil and link_spell ~= NOT_LINKED and link_spell ~= spell.spell_name then
		spell.prototype = PROTO_LINKABLE;
		local s = GetSpell(self:GetParent().spellList(),link_spell);
		if s ~= nil then
			spell.link_to = s.spell_id;
		end
	end
	
	if _G[self:GetParent():GetName().."DisableStackButton"]:GetChecked() then
		spell.disable_stacks = true;
	end

	if _G[self:GetParent():GetName().."DisableGlowButton"]:GetChecked() then
		spell.disable_glow = true;
	end
	
	if _G[self:GetParent():GetName().."SpellIsProjectileButton"]:GetChecked() then
		spell.is_projectile = true;
	end
	
	SpellRedux:NewSpell(spell, self:GetParent().spellList());
	
	self:GetParent().clearBoxes(self:GetParent())
end

function SpellReduxSettings_deleteSpell(self, button, down)
	local spellName = _G[self:GetParent():GetName().."SpellNameEdit"]:GetText();
	if spellName ~= nil and spellName ~= '' then	
		SpellRedux:DeleteSpell(spellName, self:GetParent().spellList())	
		self:GetParent().clearBoxes(self:GetParent());
	end
end

function SpellReduxSettings_onOpenSpells(frame, level, menuList, deselectItem, selectFunc)
	local panel = frame:GetParent();
	local spellList = panel.spellList();
	local info      = {};
	info.func       = selectFunc;
	info.arg1		= frame;
	if deselectItem ~= nil then
		info.text       = deselectItem; --localize this
		info.arg2		= deselectItem;
		info.checked	= UIDropDownMenu_GetSelectedName(frame) == deselectItem;
		UIDropDownMenu_AddButton(info)
	end
	for i, spell in ipairs(spellList) do
		info.text       = spell.spell_name;
		info.arg2		= spell.spell_name;
		info.checked	= UIDropDownMenu_GetSelectedName(frame) == info.text ;
		if spell.icon ~= nil then
			info.icon = spell.icon;
		else
			if spell.spell_id ~= nil then
				info.icon = select(3, GetSpellInfo(spell.spell_id));
			else
				info.icon = select(3, GetSpellInfo(spell.spell_name));
			end
		end
		UIDropDownMenu_AddButton(info);
	end
end

function SpellReduxSettings_onOpenSpellsInPlace(frame, level, menuList)
	SpellReduxSettings_onOpenSpells(frame, level, menuList, NOT_LINKED, SpellReduxSettings_onSelectSpellGeneric);
end

function SpellReduxSettings_onOpenSpellsWithNew(frame, level, menuList) 
	SpellReduxSettings_onOpenSpells(frame, level, menuList, NEW_SPELL, frame:GetParent().onSelectSpell);
end

function SpellReduxSettings_onOpenActiveSpells(frame, level, menuList) 

	local panel = frame:GetParent();
	local spellList = SpellReduxSettings:getActiveSpells(panel.activeSpellTarget, panel.activeSpellTargetFilter);
	if spellList == nil then
		return;
	end
	
	local info = {};
	info.func = SpellReduxSettings_onSelectSpellGeneric;
	info.arg1 = frame;
	for k, spell in pairs(spellList) do
		info.text       = spell.spell_name;
		info.arg2		= spell.spell_name;
		info.value		= spell.spell_id;
		info.checked	= UIDropDownMenu_GetSelectedName(frame) == info.text ;
		info.icon		= spell.icon;
		UIDropDownMenu_AddButton(info);
	end
end 

function SpellReduxSettings_onSelectSpellGeneric(self, arg1, arg2, checked)
	UIDropDownMenu_SetSelectedName(arg1, arg2, false) 
end 

function SpellReduxSettings_onSelectSpell(self, arg1, arg2, checked)
	local frame = arg1:GetParent();
	UIDropDownMenu_SetSelectedName(arg1, arg2, false) 

	if (arg2 == NEW_SPELL) then
		frame.clearBoxes(frame);
	else
		local spellList = frame.spellList();
		local spell = GetSpell(spellList,arg2);
		_G[frame:GetName().."SpellNameEdit"]:SetText(arg2);		
		UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellTypeSelect"], spell.spell_type,false);
		UIDropDownMenu_SetText(_G[frame:GetName().."SpellTypeSelect"], spell.spell_type);
		if spell.spell_type == DOT then
			_G[frame:GetName().."AppliedByEdit"]:SetText(""); 
			_G[frame:GetName().."AppliedByEdit"]:Disable(); 
		elseif spell.spell_type == DEBUFF or spell.spell_type == BUFF then
			_G[frame:GetName().."AppliedByEdit"]:SetText(""); 
			if spell.applied_by ~= nil then 
				_G[frame:GetName().."AppliedByEdit"]:SetText(spell.applied_by);
			end 
			_G[frame:GetName().."AppliedByEdit"]:Enable(); 
		end 
		if spell.prototype == PROTO_LINKABLE then
			local linkedSpell = GetSpell(spellList, spell.link_to)
			if linkedSpell ~= nil then
				UIDropDownMenu_SetSelectedName(_G[frame:GetName().."InPlaceOfSelect"], linkedSpell.spell_name,false);
				UIDropDownMenu_SetText(_G[frame:GetName().."InPlaceOfSelect"], linkedSpell.spell_name);
			end
		else 
			UIDropDownMenu_SetSelectedName(_G[frame:GetName().."InPlaceOfSelect"], NOT_LINKED,false);
			UIDropDownMenu_SetText(_G[frame:GetName().."InPlaceOfSelect"], NOT_LINKED);
		end
		_G[frame:GetName().."SpellIsProjectileButton"]:SetChecked(spell.is_projectile == true);
		_G[frame:GetName().."DisableStackButton"]:SetChecked(spell.disable_stacks == true);
		_G[frame:GetName().."DisableGlowButton"]:SetChecked(spell.disable_glow == true);
		UIDropDownMenu_SetSelectedName(_G[frame:GetName().."SpellSelectActive"], "",false);
		UIDropDownMenu_SetText(_G[frame:GetName().."SpellSelectActive"], "");
		_G[frame:GetName().."SpellNameEdit"]:Disable();
	end
end
